#8. Reamostragem e Simulao

#palmitos
	#1.1
	eutad <- read.table("palmadulto.txt", header = T, sep = "\t")
	head(eutad)
	
	#1.2
	dist=matrix(NA, ncol=102, nrow=102)

	#1.3
	for(i in 1:101)
	    {
	        for(j in (i+1):102)
	            {
	                difx2=(eutad$gx[i]-eutad$gx[j])^2
	                dify2=(eutad$gy[i]-eutad$gy[j])^2
	                dist[i,j]<-sqrt(difx2 + dify2)
	                dist[j,i]<-sqrt(difx2 + dify2)
	            }
          
	    }

	#1.4
	(nn<-apply(dist, 1, min, na.rm=TRUE))
	(mnn<-mean(nn))

	#1.5
	nsim <- 1000 	#nmero de simulaes
	resultado <- rep(NA, nsim)

	#1.6
	resultado[1] <- mnn

	#1.7
	for (k in 2:nsim)
		{
	#1.8.1
	    xsim <- runif(length(nn),0,320)
	#1.8.2
	    ysim <- runif(length(nn),0,320)
	#1.8.3
	    xysim <- data.frame(xsim, ysim)
	#1.8.3
	    dist.m <- as.matrix(dist(xysim, diag=F))
	    diag(dist.m) <- NA
	    simu <- apply(dist.m, 1, min, na.rm=TRUE)
	#1.8.4
	    resultado[k] <- mean(simu)
	#1.8.5
		}

	#1.9
	hist(resultado, breaks=25)
	abline(v=resultado[1],col="red")

	#1.10. bicaudal
	p.valor <- sum(resultado>=resultado[1]|resultado<=resultado[1]*-1)/length(resultado)


#animais

	#importando e preparando os dados
	ani <- read.table("animais.txt", header = T, sep = ";")
	ani <- na.omit(ani)
	ani$body <- as.numeric(ani$body)
	ani$brain <- as.numeric(ani$brain)	
	
	#2.1
	log.body <- log(ani$body)
	log.brain <- log(ani$brain)
	beta <- sum((log.body - mean(log.body))*(log.brain - mean(log.brain)))/sum((log.body-mean(log.body))^2)
	
	#2.2
	nsim <- 1000 	#nmero de simulaes
	resultado.b <- as.vector(matrix(NA,nsim))

	#2.3
	resultado.b[1] <- beta

	#2.4
	for(i in 2:nsim)
		{
	#2.5
			sim_brain <- sample(log.brain)
	#2.6
			resultado.b[i] <- sum((log.body-mean(log.body))*(sim_brain-mean(sim_brain)))/sum((log.body-mean(log.body))^2)	
	#2.7
		}

	#2.8
	hist(resultado.b, breaks=35)
	abline(v=resultado.b[1],col="red")

	#2.9 bicaudal
	p.valor <- sum(resultado.b>=resultado.b[1]|resultado.b<=resultado.b[1]*-1)/length(resultado.b)